#!/usr/bin/php
<?php

/*
 *   StudNET-Client
 *   
 *   Copyright 2009 Johannes Matschke http://www.ungelesen.net
 *   
 *   You may use this software under the terms of the MIT License:
 *   
 *   Permission is hereby granted, free of charge, to any person obtaining
 *   a copy of this software and associated documentation files (the
 *   "Software"), to deal in the Software without restriction, including
 *   without limitation the rights to use, copy, modify, merge, publish,
 *   distribute, sublicense, and/or sell copies of the Software, and to
 *   permit persons to whom the Software is furnished to do so, subject to
 *   the following conditions:
 *   
 *   The above copyright notice and this permission notice shall be
 *   included in all copies or substantial portions of the Software.
 *   
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 *   LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 *   OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 *   WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

$mieternummer = '';
$passwort = '';

$ip = '139.18.143.253'; // IP des Login-Servers
$fingerprint = 'ed:1e:b7:bf:2f:ff:8b:74:85:47:4e:f7:64:ac:b5:43'; //kann leer bleiben

$max_retry_connect = 1; //Höchstzahl der Wiederverbindungsversuche in Folge
$reconnect_wait = 20; //Zeit bis zum erneuten Verbindungsversuch in Sekunden

//----------------------------------------------

function get_ssh_shell($ip, $fp, $name, $pw, &$error)
{
	//Zum Server verbinden
	if (!$connection = @ssh2_connect($ip))
	{
		$error = 'Server nicht erreichbar';
		return FALSE;
	}

	//Falls ein Fingerprint angegeben ist, wird dieser mit dem Server abgeglichen
	if ($fp)
	{
		$server_fp = @ssh2_fingerprint($connection, SSH2_FINGERPRINT_MD5 | SSH2_FINGERPRINT_HEX);
		if (strtoupper(str_replace(':','',$fp)) != $server_fp)
		{
			$error = 'Ungültiger Fingerprint';
			return FALSE;
		}
	}

	//Mit Benutzername und Passwort authentifizieren
	if (!@ssh2_auth_password($connection,$name,$pw))
	{
		$error = 'Authentifizierung fehlgeschlagen';
		return FALSE;
	}


	//Shellzugriff aktivieren
	if (!$shell = @ssh2_shell($connection))
	{
		$error = 'Shellzugriff fehlgeschlagen';
		return FALSE;
	}
return $shell;
}



//Anzahl der Wiederverbindungsversuche seit der letzten erfolgreichen Verbindung
//Steht zu Beginn auf -1, damit der erste Verbindungsversuch nicht als Wiederverbinden zählt
$retry_connect_count = -1;

while ($retry_connect_count < $max_retry_connect)
{
	//Verbindungsversuch
	$retry_connect_count++;
	$get_ssh_shell_error = '';
	$ssh_shell = get_ssh_shell($ip, $fingerprint, $mieternummer, $passwort, $get_ssh_shell_error);

	if (!$ssh_shell)
	{
		echo $get_ssh_shell_error.".\n";
	}
	else
	{
		$retry_connect_count = 0;
		
		//Die Shell erst mal munter werden lassen
		sleep(1);

		//Aller 10 Sekunden nachschauen, ob der Server was geschrieben hat.
		//Dann ein Leerzeichen an den Server senden
		//Wenn der Server das Leerzeichen nicht zurücksendet, ist die Verbindung tot
		while ($chars = fread($ssh_shell,1024))
		{
			if (trim($chars," ")!="") echo $chars;
			fwrite($ssh_shell, " ");
			sleep(10);
		}

		echo "\nVerbindungsabbruch.\n";
		fclose($ssh_shell);
	}

	if ($retry_connect_count < $max_retry_connect)
	{
		echo "\nNoch ".($max_retry_connect - $retry_connect_count)." Verbindungsversuch(e).\n";
		echo "Nächster Versuch in ".$reconnect_wait." Sekunden.\n\n";
		sleep($reconnect_wait);
	}
}
?>
